package combinatorParsing2

/** A class for source positions
 *  @param source The contents of the source file referred to by the position
 *  @param line   The line number referred to by the position
 *  @param line   The column number referred to by the position
 */
class CharArrayPosition(val source: Array[char], val line: int, val column: int) extends Position {

  protected def lineContents(lnum: int) = {
    var i = 0
    var l = 1
    while (i < source.length && l < lnum) {
      while (i < source.length && source(i) != '\n') i = i + 1
      i = i + 1
      l = l + 1
    }
    var chars = new StringBuffer
    while (i < source.length && source(i) != '\n') {
      chars append source(i)
      i = i + 1
    }
    chars.toString
  }
}
    
