package combinatorParsing2;

object implicitCoercions {
  implicit def pair2fun2[A, B, C]           (f: (A, B) => C): Pair[A, B] => C = {p: Pair[A, B] => f(p._1, p._2) }
  implicit def triple2fun3[A, B, C, D]      (f: (A, B, C) => D)       = {p: Pair[Pair[A, B], C] => f(p._1._1, p._1._2, p._2) }
  implicit def tuple42fun4[A, B, C, D, E]   (f: (A, B, C, D) => E)    = {p: Pair[Pair[Pair[A, B], C], D] => f(p._1._1._1, p._1._1._2, p._1._2, p._2) }
  implicit def tuple52fun5[A, B, C, D, E, F](f: (A, B, C, D, E) => F) = {p: Pair[Pair[Pair[Pair[A, B], C], D], E] => f(p._1._1._1._1, p._1._1._1._2, p._1._1._2, p._1._2, p._2) } 
}
